﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;


namespace ServerSIP 
{
    public partial class QueueForm : Form
    {
        public QueueForm()
        {
            InitializeComponent();
        }
                
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
                
        private void BtnAddQueue_Click(object sender, EventArgs e)
        {
            if (!AddQueueChecks()) 
                return;
    
            if(ComboQueueName.FindStringExact(ComboQueueName.Text) != -1)
            {
                if(MessageBox.Show("Queue already exists, do you want to continue?", "VaxVoIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.No)
                {
                    return;
                }
            }

            ArrayList objAgentList = new ArrayList();
            GetAgentNameAll(ref objAgentList);

            if (!cVaxQueue.AddQueue(ComboQueueName.Text, GetProcessMode(), GetProcessType(), objAgentList, EditQueueMusicFile.Text, EditQueueDialToneFile.Text))
            {
                MessageBox.Show("Queue could not be added/updated or Please start the server first.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
          
            if(!ComboQueueName.Items.Contains(ComboQueueName.Text))
                ComboQueueName.Items.Add(ComboQueueName.Text);

            MessageBox.Show("Queue added/updated successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private Boolean AddQueueChecks()
        {
            if (ComboQueueName.Text.Length == 0)
            {
                MessageBox.Show("Please enter Queue Name", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return false;
            }

            if (ComboProcessMode.Text.Length == 0)
            {
                MessageBox.Show("Please select Process Mode", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return false;
            }

            if (ComboProcessMode.Text.Length == 0)
            {
                MessageBox.Show("Please select Process Mode Type Free/Any", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return false;
            }

            return true;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void BtnRemoveQueue_Click(object sender, EventArgs e)
        {
            if(ComboQueueName.Text == "")
                return;
            
            cVaxQueue.RemoveQueue(ComboQueueName.Text);
            ComboQueueName.Items.Remove(ComboQueueName.Text);
            
            ClearDlgUI();

            if (ComboQueueName.Items.Count > 0)
              ComboQueueName.SelectedIndex = 0;

            ShowQueueDetails();
            MessageBox.Show("Queue removed successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void BtnQueueClear_Click(object sender, EventArgs e)
        {
            ClearDlgUI();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void BtnAddQueueAgent_Click(object sender, EventArgs e)
        {
            if(ListBoxLogin.FindStringExact(ComboAgentName.Text) != -1)
            {
                return;
            }

            ListBoxLogin.Items.Insert(0, ComboAgentName.Text);
        }

        private void BtnRemoveQueueAgent_Click(object sender, EventArgs e)
        {
            ListBoxLogin.Items.Remove(ListBoxLogin.SelectedItem);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void BtnClearQueueAgent_Click(object sender, EventArgs e)
        {
            ClearDlgUI();
        }

        private void ClearDlgUI()
        {
            ComboQueueName.Text = "";

            if (ComboProcessMode.Items.Count > 0)
                ComboProcessMode.SelectedIndex = 0;

            if (ComboProcessType.Items.Count > 0)
                ComboProcessType.SelectedIndex = 0;

            if (ComboAgentName.Items.Count > 0)
                ComboAgentName.SelectedIndex = 0;
            
            EditQueueMusicFile.Text = "";
            EditQueueDialToneFile.Text = "";
                        
            ListBoxLogin.Items.Clear();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void GetAgentNameAll(ref ArrayList objList)
        {
            foreach (String sAgentName in ListBoxLogin.Items)
            {
                objList.Add(sAgentName);
            }
        }

        private int GetProcessMode()
        {
            if(ComboProcessMode.SelectedIndex == -1)
            {
                MessageBox.Show("Please select a process mode.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return -1;
            }

            return ComboProcessMode.SelectedIndex;
        }

        private int GetProcessType()
        {
            if (ComboProcessType.SelectedIndex == -1)
            {
                MessageBox.Show("Please select a process type.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return -1;
            }

            return ComboProcessType.SelectedIndex;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void AddProcessMode()
        {
            ComboProcessMode.Items.Clear();

            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_RING_ALL);
            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_HUNT_RANDOM);
            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_ROUND_ROBIN);
            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_LEAST_ANSWERED);
            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_LEAST_TALK_TIME);
            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_LONGEST_WAITING);
            ComboProcessMode.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_PRIORITIZED_HUNT);

            ComboProcessMode.SelectedIndex = 0;
        }

        private void AddProcessType()
        {
            ComboProcessType.Items.Clear();

            ComboProcessType.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_PROCESS_TYPE_FREE);
            ComboProcessType.Items.Add(cVaxDefine.GROUP_PROCESS_MODE_PROCESS_TYPE_ANY);

            ComboProcessType.SelectedIndex = 0;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void AddUsers()
        {
            ComboAgentName.Items.Clear();

            ArrayList objListUsers = new ArrayList();
            cStoreUser.GetUserAll(ref objListUsers);

            if(objListUsers.Count <= 0) return;

            for (int nIndex = 0; nIndex < objListUsers.Count; nIndex++)
                ComboAgentName.Items.Add(objListUsers[nIndex]);

            if(ComboAgentName.SelectedIndex == -1 && ComboAgentName.Items.Count > 0)
                ComboAgentName.SelectedIndex = 0;
        }

        private void AddQueues()
        {
            ComboQueueName.Items.Clear();

            ArrayList objListQueueName = new ArrayList();
            cStoreQueue.GetQueueNameAll(ref objListQueueName);

            if(objListQueueName.Count <= 0)
                return;

            foreach (String sQueueName in objListQueueName)
            {
                ComboQueueName.Items.Add(sQueueName);
            }

            if(ComboQueueName.Items.Count > 0)
                ComboQueueName.SelectedIndex = 0;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public void OnSetActive()
        {
            AddUsers();

            AddProcessMode();
            AddProcessType();

            AddQueues();
            ShowQueueDetails();
        }

        private void ComboQueueName_SelectedIndexChanged(object sender, EventArgs e)
        {
            ShowQueueDetails();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void ShowQueueDetails()
        {
            String sQueueName = ComboQueueName.Text;

            if (sQueueName.Length == 0)
                return;
                                    
            int nProcessMode = -1, nProcessType = -1;
            String sQueueMusicFile = "", sQueueDialToneFile = "";

            ArrayList objAgentList = new ArrayList();
            cStoreQueue.GetQueue(sQueueName, ref nProcessMode, ref nProcessType, ref objAgentList, ref sQueueMusicFile, ref sQueueDialToneFile);
            
            if (ComboProcessMode.Items.Count > 0)
                ComboProcessMode.SelectedIndex = 0;

            if (ComboProcessType.Items.Count > 0)
                ComboProcessType.SelectedIndex = 0;
                        
            EditQueueMusicFile.Text = sQueueMusicFile;
            EditQueueDialToneFile.Text = sQueueDialToneFile;

            ListBoxLogin.Items.Clear();

            foreach (String sUserName in objAgentList)
               ListBoxLogin.Items.Add(sUserName);
        }
                
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
 
    }
}
