﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cVaxStealthListen
    {
        private static int m_nMusicWaitingStealthListenId = -1;

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static void ResetAll()
        {
            m_nMusicWaitingStealthListenId = -1;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static void OnIncomingCall(int nSessionId, String sCallerName, String sCallerId, String sDialNo, int nFromPeerType, String sFromPeerName, String sRouteUID)
        {
            if(nFromPeerType != cVaxServerCOM.VAX_PEER_TYPE_USER || cVaxUser.IsUserTypeAdmin(sFromPeerName) == false)
            {
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 403, "Forbidden");
                return;
            }

            cVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID);
            cVaxServerSIP.mVaxSIP.AdjustCallSessionVoiceType(nSessionId, -1, cVaxServerCOM.VAX_AUDIO_TYPE_ADMIN);

            StartMusic(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO);
        }

        public static void OnStealthListenerAttached(int nAttachType, int nStealthSessionId, int nAttachSessionId, int nAttachChannelId)
        {
            if (nAttachType == cVaxServerCOM.VAX_STEALTH_LISTENER_FREE)
            {
                StartMusic(nStealthSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO);
            }

            else if (nAttachType == cVaxServerCOM.VAX_STEALTH_LISTENER_BUSY)
            {
                StopMusic(nStealthSessionId);
            }
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static Boolean LoadMusic(String sFileName)
        {
            if (m_nMusicWaitingStealthListenId != -1)
            {
                cVaxServerSIP.mVaxSIP.UnLoadWaveID(m_nMusicWaitingStealthListenId);
                m_nMusicWaitingStealthListenId = -1;
            }

            m_nMusicWaitingStealthListenId = cVaxServerSIP.mVaxSIP.LoadWaveFile(sFileName);
            return (m_nMusicWaitingStealthListenId != -1);
        }

        private static Boolean StartMusic(int nSessionId, int nChannelId)
        {
            int nMusicId = m_nMusicWaitingStealthListenId;

            if (nMusicId == -1)
                return false;

            return cVaxServerSIP.mVaxSIP.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, true, 0);
        }

        private static void StopMusic(int nSessionId)
        {
            if (m_nMusicWaitingStealthListenId == -1)
                return;

            cVaxServerSIP.mVaxSIP.PlayWaveStopToCallSession(nSessionId, -1, -1);
        }
    }
}
