﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cStoreCallPickUp
    {
        const String CALL_PICKUP_GROUP_ROOT_PATH = "CallPickUpGroups\\";
                            
        //////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////

        public static Boolean AddGroup(String sGroupName, ArrayList objMemberList)
        {
            RemoveGroup(sGroupName);
            
            if(sGroupName.Length == 0)
                return false;

            String sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetTEXT(sKeyPath, "CallPickUpGroupName", sGroupName);

            foreach (String sMemberName in objMemberList)
            {
                cStoreCallPickUp.AddGroupMember(sGroupName, sMemberName);
            }

            objStore.Close();
            return true;
        }

        public static void RemoveGroup(String sGroupName)
        {
            if(sGroupName.Length == 0)
                return;

            String sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }

        public static void GetGroupNameAll(ref ArrayList objList)
        {
            objList.Clear();

            String sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static Boolean GetGroup(String sGroupName, ref ArrayList objMemberList)
        {
            if (sGroupName.Length == 0)
                return false;

            cStoreCallPickUp.GetMemberNameAll(sGroupName, ref objMemberList);
            return true;
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////
               
        private static Boolean AddGroupMember(String sGroupName, String sUserName)
        {
            if(sGroupName.Length == 0 || sUserName.Length == 0)
                return false;

            String sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sGroupName + "\\" + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            Boolean bResult = objStore.SetTEXT(sKeyPath, "UserName", sUserName);
            objStore.Close();

            return bResult;
        }

        private static void RemoveGroupMember(String sGroupName, String sUserName)
        {
            if(sGroupName.Length == 0 || sUserName.Length == 0)
                return;

            String sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sGroupName + "\\" + sUserName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        private static void GetMemberNameAll(String sGroupName, ref ArrayList objList)
        {
            objList.Clear();

            if(sGroupName.Length == 0)
                return;
            
            String sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static Boolean IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            Boolean bResult = objStore.IsKeyExist(CALL_PICKUP_GROUP_ROOT_PATH);
            
            objStore.Close();
            return bResult;
        }
    }
}
