﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cStoreRingGroup
    {
        const String RING_GROUP_ROOT_PATH = "RingGroups\\";
               
        //////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////

        public static Boolean AddGroup(String sGroupName, int nProcessMode, int nProcessType, ArrayList objAgentList)
        {
            RemoveGroup(sGroupName);

            if (sGroupName.Length == 0)
                return false;

            String sKeyPath = RING_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            if (!objStore.SetTEXT(sKeyPath, "RingGroupName", sGroupName))
            {
                objStore.Close();
                return false;
            }

            cStoreRingGroup.AddGroupAgentNameAll(sGroupName, objAgentList);
            cStoreRingGroup.SetGroupProcessMode(sGroupName, nProcessMode, nProcessType);

            objStore.Close();
            return true;
        }
        
        public static void RemoveGroup(String sGroupName)
        {
            if(sGroupName.Length == 0)
                return;

            String sKeyPath = RING_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }

        public static void GetGroupNameAll(ref ArrayList objList)
        {
            String sKeyPath = RING_GROUP_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();
            
            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static Boolean GetGroup(String sGroupName, ref int nProcessMode, ref int nProcessType, ref ArrayList objAgentList)
        {
            if (sGroupName.Length == 0)
                return false;

            cStoreRingGroup.GetGroupAgentNameAll(sGroupName, ref objAgentList);
            cStoreRingGroup.GetGroupProcessMode(sGroupName, ref nProcessMode, ref nProcessType);

            return true;
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        private static Boolean SetGroupProcessMode(String sGroupName, int nProcessMode, int nProcessType)
        {
            if(sGroupName.Length == 0)
                return false;

            String sKeyPath = RING_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetINT(sKeyPath, "ProcessMode", nProcessMode);
            objStore.SetINT(sKeyPath, "ProcessType", nProcessType);

            objStore.Close();
            return true;
        }

        private static Boolean GetGroupProcessMode(String sGroupName, ref int nProcessMode, ref int nProcessType)
        {
            if(sGroupName.Length == 0)
                return false;

            String sKeyPath = RING_GROUP_ROOT_PATH + sGroupName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.GetINT(sKeyPath, "ProcessMode", ref nProcessMode, cVaxServerCOM.VAX_RING_GROUP_PROCESS_MODE_RING_ALL);
            objStore.GetINT(sKeyPath, "ProcessType", ref nProcessType, cVaxServerCOM.VAX_RING_GROUP_PROCESS_TYPE_FREE);

            objStore.Close();
            return true;
        }

        ///////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////
      
        private static void AddGroupAgentNameAll(String sGroupName, ArrayList objList)
        {
            if (sGroupName.Length == 0)
                return;

            cStoreRegistry objStore = new cStoreRegistry();

            foreach (String sUserName in objList)
            {
                String sKeyPath = RING_GROUP_ROOT_PATH + sGroupName + "\\" + sUserName;
                objStore.SetTEXT(sKeyPath, "UserName", sUserName);
            }

            objStore.Close();
        }
                
        private static void GetGroupAgentNameAll(String sGroupName, ref ArrayList objList)
        {
            if(sGroupName.Length == 0)
                return;

            String sKeyPath = RING_GROUP_ROOT_PATH + sGroupName; ;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        ///////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////
        
        public static Boolean IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            Boolean bResult = objStore.IsKeyExist(RING_GROUP_ROOT_PATH);

            objStore.Close();
            return bResult;
        }
    }
}
